module.exports = {
  preset: 'ts-jest',
  testEnvironmentOptions: {
    resources: 'usable', // jsdom 加载资源
    runScripts: 'dangerously' // jsdom 运行script脚本
  },
  collectCoverage: true,
  collectCoverageFrom: ['./src/**/*.ts', '!./src/index.ts', '!./sc/type.ts'], // 测试覆盖率
  coverageDirectory: './coverage', // 输出覆盖率报告目录
  coverageReporters: ['html', 'text-summary'], // 输出覆盖率报告格式
  reporters: [
    // 测试报告
    [
      './node_modules/jest-html-reporter',
      {
        pageTitle: 'Test Report', // 输出页面标题
        outputPath: './report/test-report.html', // 插件将会输出的HTML报告的路径。
        includeFailureMsg: true, // 为每个失败的测试输出详细的失败消息。
        includeSuiteFailure: true,
        includeObsoleteSnapshots: true
      }
    ]
  ],
  testMatch: ['**/*.test.ts'],
  // 整体覆盖率
  coverageThreshold: {
    global: {
      statements: 90,
      branches: 80,
      functions: 90,
      lines: 90
    }
  }
}
