import path from 'path'
import typescript from 'rollup-plugin-typescript2'
import resolve from '@rollup/plugin-node-resolve' // 你的包用到第三方npm包
import commonjs from '@rollup/plugin-commonjs' // 你的包用到的第三方只有commonjs形式的包
import { terser } from 'rollup-plugin-terser' // 压缩
export default {
  input: './src/index.ts',
  output: [
    {
      // 适合在jquery，vue，node使用
      file: 'dist/index.umd.js',
      name: 'index.umd',
      format: 'umd',
      plugins: [terser()],
    },
    {
      // 适合在直接用esmodule中使用，按需加载
      file: 'dist/index.esm.js',
      format: 'esm',
    },
    {
      // 整体引用
      file: 'dist/index.cjs.js',
      format: 'cjs',
    },
  ],
  plugins: [
    typescript({
      tsconfig: path.resolve(__dirname, './tsconfig.json'),
      useTsconfigDeclarationDir: true,
    }),
    resolve(),
    commonjs(),
  ],
}
