/**
 *
 * 浮点数相加
 * @category  math
 * @param {number} arg1
 * @param {number} arg2
 * @return {*}  {number}
 * @author hzxiongxu
 * @date 20210520
 */
export function floatAdd(arg1: number, arg2: number): number {
  let r1
  let r2
  try {
    r1 = arg1.toString().split('.')[1].length
  } catch (e) {
    r1 = 0
  }
  try {
    r2 = arg2.toString().split('.')[1].length
  } catch (e) {
    r2 = 0
  }
  const m = Math.pow(10, Math.max(r1, r2))
  return Math.round(arg1 * m + arg2 * m) / m
}

/**
 *
 * 浮点数减法
 * @category  math
 * @param {number} arg1
 * @param {number} arg2
 * @return {*}  {number}
 * @author hzxiongxu
 * @date 20210520
 */
export function floatSub(arg1: number, arg2: number): number {
  let r1
  let r2
  try {
    r1 = arg1.toString().split('.')[1].length
  } catch (e) {
    r1 = 0
  }
  try {
    r2 = arg2.toString().split('.')[1].length
  } catch (e) {
    r2 = 0
  }
  const m = Math.pow(10, Math.max(r1, r2))
  // 动态控制精度长度
  const n = r1 >= r2 ? r1 : r2
  // 添加了结果为整数时精度长度不准确的问题
  const r = ((arg1 * m - arg2 * m) / m).toFixed(n)
  if (r.split('.')[1]) {
    if (Number(r.split('.')[1]) === 0) {
      return +r.split('.')[0]
    }
  }
  return +((arg1 * m - arg2 * m) / m).toFixed(n)
}
