import { moneyFormat, cardNoFormat, mobileNoFormat } from '../src/format'
describe('cardNoFormat', () => {
  it('银行卡格式化', () => {
    expect(cardNoFormat('')).toEqual('')
    expect(cardNoFormat('6224556879543216')).toEqual('6224 5568 7954 3216')
    expect(cardNoFormat('62245568795432166224556879543216')).toEqual('6224 5568 7954 3216 6224 5568 7')
  })
})

describe('mobileNoFormat', () => {
  it('手机号格式化', () => {
    expect(mobileNoFormat('')).toEqual('')
    expect(mobileNoFormat('15647896330')).toEqual('156 4789 6330')
  })
})

describe('moneyFormat', () => {
  it('金额格式化', () => {
    expect(moneyFormat(110, { unit: '', symbol: '' })).toEqual('110.00')
    expect(moneyFormat(110, { unit: '', symbol: '￥' })).toEqual('￥110.00')
    expect(moneyFormat(110, { unit: '元', symbol: '' })).toEqual('110.00元')
    expect(moneyFormat(110, { unit: '元', symbol: '￥' })).toEqual('￥110.00元')
    expect(moneyFormat(110.1, { unit: '美元', symbol: '$' })).toEqual('$110.10美元')
    expect(moneyFormat(1110.22, { unit: '元', symbol: '￥' })).toEqual('￥1,110.22元')
    expect(moneyFormat(110.234, { unit: '元', symbol: '￥', decimalPlaces: 1 })).toEqual('￥110.2元')
    expect(moneyFormat(1111110.247, { unit: '元', symbol: '￥' })).toEqual('￥1,111,110.25元')
    expect(moneyFormat(1111110.247, { unit: '元', symbol: '￥', decimalPlaces: 0 })).toEqual('￥1,111,110元')
    expect(moneyFormat(1111110.247, { unit: '', symbol: '', decimalPlaces: 0, useThousands: false })).toEqual('1111110')
  })
})
